DEFINT A-Z

' Set for 640x480, 16 color (VGA required).
SCREEN 12

' Set to update each second.
ON TIMER(1) GOSUB Update
TIMER ON

' Get time and calculate initial hand angles.
hour = VAL(TIME$)
IF hour > 12 THEN hour = hour - 12
minute = VAL(MID$(TIME$, 4, 2))
second = VAL(MID$(TIME$, 7, 2))
angleH = 360 - (30 * hour + minute / 2)
angleM = 360 - (6 * minute)
angleS = 360 - (6 * second)

' Draw a circle with a bright white border.
CIRCLE (320, 240), 180, 15

' Fill it with white.
PAINT STEP(0, 0), 7, 15

' Reset the current draw point to correct
' for problems cause by STEP(0,0).
DRAW "BM320,240"

' Draw hour and minute/second marks.
FOR angle = 0 TO 354 STEP 6
    DRAW "TA=" + VARPTR$(angle) + "BU175"
    IF angle MOD 30 = 0 THEN
        CIRCLE STEP(0, 0), 2, 0
    ELSE
        CIRCLE STEP(0, 0), 1, 0
    END IF
    DRAW "P0,0"
    DRAW "BD175"
NEXT

' Reset the current draw point to correct
' for problems cause by STEP(0,0).
DRAW "BM320,240"

LOCATE 30, 30
PRINT "Press any key to exit...";
DO
LOOP UNTIL INKEY$ <> ""

END

Update:
    ' Update time variables.
    second = second + 1
    IF second > 59 THEN
        second = 0
        minute = minute + 1
    END IF
    IF minute > 59 THEN
        minute = 0
        hour = hour + 1
    END IF
    IF hour > 12 THEN
        hour = 1
    END IF

    ' Calculate hand angles.
    angleH = 360 - (30 * hour + minute / 2)
    angleM = 360 - (6 * minute)
    angleS = 360 - (6 * second)

    ' Erase and redraw second hand.
    DRAW "C7"
    DRAW "TA=" + VARPTR$(prevAngleS) + "NU160"
    DRAW "C0"
    DRAW "TA=" + VARPTR$(angleS) + "NU160"
    prevAngleS = angleS

    ' Erase and redraw minute hand.
    DRAW "C7"
    DRAW "TA=" + VARPTR$(prevAngleM) + "NU130"
    DRAW "C0"
    DRAW "TA=" + VARPTR$(angleM) + "NU130"
    prevAngleM = angleM

    ' Erase and redraw hour hand.
    DRAW "C7"
    DRAW "TA=" + VARPTR$(prevAngleH) + "NU100"
    DRAW "C0"
    DRAW "TA=" + VARPTR$(angleH) + "NU100"
    prevAngleH = angleH

    ' Draw a black hub.
    CIRCLE STEP(0, 0), 2, 8
    PAINT STEP(0, 0), 0, 8

    ' Reset the current draw point to correct
    ' for problems cause by STEP(0,0).
    DRAW "BM320,240"

    ' Update digit display.
    hour$ = LTRIM$(RTRIM$(STR$(hour)))
    IF LEN(hour$) < 2 THEN hour$ = "0" + hour$
    minute$ = LTRIM$(RTRIM$(STR$(minute)))
    IF LEN(minute$) < 2 THEN minute$ = "0" + minute$
    second$ = LTRIM$(RTRIM$(STR$(second)))
    IF LEN(second$) < 2 THEN second$ = "0" + second$
    LOCATE 1, 70
    PRINT hour$; ":"; minute$; ":"; second$;
    IF VAL(TIME$) < 12 THEN PRINT "a" ELSE PRINT "p";

    RETURN

